/*
 * Copyright (C) 2025-2026  Tim Zimmermann <tim@aglais.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.aglais.zms.ui.tab;

import org.aglais.zms.AglaisZMS;
import org.aglais.zms.ui.tab.settings.SettingsBackupTab;
import org.aglais.zms.ui.tab.settings.SettingsProfileTab;
import org.jetbrains.annotations.NotNull;

import javax.swing.*;

/**
 * Tab for managing settings.
 */
public class SettingsTab extends Tab implements ISubTabbedTab {

    private JPanel contentPane;
    private JTabbedPane settingsTabbedPane;

    private final SubTab<?>[] tabs;

    /**
     * Creates a new SettingsTab with the given {@link AglaisZMS} instance
     *
     * @param zms The {@link AglaisZMS} instance this tab belongs to
     */
    public SettingsTab(AglaisZMS zms) {
        super(zms);

        tabs = new SubTab[] {
                new SettingsProfileTab(zms, this),
                new SettingsBackupTab(zms, this)
        };
    }

    @Override
    public void onShow() {
        registerSubTabs();
    }

    @Override
    public @NotNull JComponent getContentPane() {
        return contentPane;
    }

    @Override
    public JTabbedPane getTabbedPane() {
        return settingsTabbedPane;
    }

    @Override
    public SubTab<?>[] getTabs() {
        return tabs;
    }
}
